﻿// ==========================================================================================================
//  
//   File ID: Testworks 3 - WR.Testworks3.Browser - App.xaml.cs 
//  
//   Copyright 2011-2016
//   WR Medical Electronics Company
//  
//   Last Changed By: cdo - Collin D. O'Connor
//   Last Changed Date: 8:29 AM, 06/07/2016
//   Created Date: 12:22 PM, 11/06/2013
//  
//   Notes:
//   
// ==========================================================================================================

namespace QuickAccess.Browser.Views {
    #region Imported Namespaces

    using System.Threading;
    using System.Windows;
    using System.Windows.Threading;

    #endregion

    ///============================================================================================
    /// <summary>   Interaction logic for App.xaml. </summary>
    ///
    /// <remarks>
    /// CODE SMELL.  Eventually find a way to pass out these startup routines directily to
    /// ApplicationLauncher.cs.
    /// </remarks>
    ///
    /// <seealso cref="T:System.Windows.Application"/>
    ///============================================================================================
    public partial class App : Application {
        private const string AppGuid = "4C5FD836-C659-4109-A6BD-0985A9AFDD6A";

        /// <summary>   The application launcher. </summary>
        private ApplicationLauncher _appLauncher;

        private void ApplicationStartup( object sender, StartupEventArgs e )
        {
            Mutex runonce = null;

            try
            {
                runonce = new Mutex( true, "Global\\" + AppGuid );
                if( runonce.WaitOne( 0, false ) )
                {
                    this._appLauncher = new ApplicationLauncher( );
                    this._appLauncher.ApplicationStartup( sender, e );
                }
                else
                {
                    MessageBox.Show( "WR Testworks 3 is already running." );
                    Current.Shutdown( );
                }
            }
            finally
            {
                if( null != runonce )
                {
                    runonce.Close( );
                }
            }
        }
        ///========================================================================================
        /// <summary>   Application exit. </summary>
        ///
        /// <remarks>   Cdo, 4/26/2016. </remarks>
        ///
        /// <param name="sender">   Source of the event. </param>
        /// <param name="e">        Exit event information. </param>
        ///========================================================================================
        private void ApplicationExit( object sender, ExitEventArgs e ) {
            // TWTHREE-891: Application bailed early to prevent two running instances. Nothing is initialized so just return.
            if ( this._appLauncher == null ) { return; }

            this._appLauncher.ApplicationExit( sender, e );
        }

        ///========================================================================================
        /// <summary>   Application unhandled exception. </summary>
        ///
        /// <remarks>   Cdo, 4/26/2016. </remarks>
        ///
        /// <param name="sender">   Source of the event. </param>
        /// <param name="e">        Dispatcher unhandled exception event information. </param>
        ///========================================================================================
        private void ApplicationUnhandledException( object sender, DispatcherUnhandledExceptionEventArgs e ) {
        }
    }
}
