﻿// ==========================================================================================================
// 
//  File ID: Testworks 3 - WR.Testworks3.GraphicsManager - ButtonGroup.cs 
// 
//  Copyright 2011-2012
//  WR Medical Electronics Company
// 
//  Last Changed By: cdo - Collin D. O'Connor
//  Last Changed Date: 8:51 AM, 26/06/2012
// 
//  Notes:
//  
// ==========================================================================================================
using System.Collections.Generic;

namespace WR.Testworks3.GraphicsManager.Models
{
    ///=================================================================================================
    /// <summary>   Button group concrete class implementation.  </summary>
    ///
    /// <remarks>   Cdo, 7/6/2011. </remarks>
    ///=================================================================================================

    public class ButtonGroup : IButtonGroup
    {
        ///=================================================================================================
        /// <summary>   Gets or sets the name of the button group. </summary>
        ///
        /// <value> The name. </value>
        ///=================================================================================================
        public string Name { get; set; }

        ///=================================================================================================
        /// <summary>   Gets or sets the description in the tooltip. </summary>
        ///
        /// <value> The description. </value>
        ///=================================================================================================
        public string Description { get; set; }

        ///=================================================================================================
        /// <summary>   Gets or sets the buttons in this group. </summary>
        ///
        /// <value> The buttons. </value>
        ///=================================================================================================
        public IList<IButton> Buttons { get; set; }
    }
}