﻿#region Imported Namespaces

using System.Collections.Generic;
using QuickAccess.GraphicsManager.Models;

#endregion

namespace QuickAccess.GraphicsManager.ViewModels {
    public class ContextualTabViewModel : TabViewModel, IContextualTabViewModel {

        private bool _isVisible;

        #region Constructors

        public ContextualTabViewModel( ITab domainObject,
                                       string name,
                                       string identifier,
                                       string description,
                                       IEnumerable<IButtonGroupViewModel> buttonGroups,
                                       bool isVisible )
            : base( domainObject, name, identifier, description, buttonGroups )
        {
            this._isVisible = isVisible;
            this.IsTimeBased = false;
        }

        #endregion

        #region IContextualTabViewModel Members

        public bool IsVisible {
            get { return this._isVisible; }
            set {
                this._isVisible = value;
                this.OnPropertyChanged( );
            }
        }

        public bool IsTimeBased
        {
            get; set;
        }

        #endregion
    }
}
