﻿#region Imported Namespaces

using System.Collections.Generic;
using System.Collections.ObjectModel;
using QuickAccess.GraphicsManager.Models;
using QuickAccess.ViewModelFramework;

#endregion

namespace QuickAccess.GraphicsManager.ViewModels {
    public class TabViewModel : BaseDomainObjectViewModel<ITab>, ITabViewModel {

        protected ObservableCollection<IButtonGroupViewModel> _buttonGroups;

        protected string _identifier;

        protected string _description;

        protected string name;

        #region Constructors

        public TabViewModel( ITab domainObject, string name, string identifier, string description, IEnumerable<IButtonGroupViewModel> buttonGroups )
            : base( domainObject ) {
            this.name = name;
            this._identifier = identifier;
            this._description = description;
            this._buttonGroups = new ObservableCollection<IButtonGroupViewModel>( buttonGroups );
        }

        #endregion

        #region ITabViewModel Members

        public string Name {
            get { return this.name; }
            set {
                this.name = value;
                this.OnPropertyChanged( );
            }
        }

        public string Identifier {
            get { return this._identifier; }
            set {
                this._identifier = value;
                this.OnPropertyChanged( );
            }
        }

        public string Description {
            get { return this._description; }
            set {
                this._description = value;
                this.OnPropertyChanged( );
            }
        }

        public ObservableCollection<IButtonGroupViewModel> ButtonGroups
        {
            get { return this._buttonGroups; }
            set
            {
                this._buttonGroups = value;
                this.OnPropertyChanged( );
            }
        }

        #endregion
    }
}
